﻿using System;
using System.Diagnostics;
using System.Diagnostics.Eventing.Reader;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Text;

namespace EventvwrMgmtDemo
{
    internal class Program
    {
        static void Main(string[] args)
        {
            //PrintLogClass();

            //PrintLogEntry("Visual Studio");

            //WriteLogToApplication();

            //WriteLogToCustomLog();

            //CreateLogFolder();

            //ClearLogEntry("Visual Studio");

            //DeleteLog();
        }

        static void PrintLogClass()
        {
            //获取所有事件日志
            var logs = EventLog.GetEventLogs();

            foreach (var item in logs)
            {
                //输出事件日志的名字(显示名字[日志名字])
                //日志名字是用于读取/写入时的名字
                Console.WriteLine(item.LogDisplayName + $"[{item.Log}]");
            }
        }

        static void PrintLogEntry(string logName)
        {
            //获取所有事件日志
            var logs = EventLog.GetEventLogs();

            foreach (var item in logs)
            {
                if (item.LogDisplayName == logName)
                {
                    foreach (EventLogEntry entry in item.Entries)
                    {
                        Console.WriteLine($"级别:{entry.EntryType}");
                        Console.WriteLine($"创建时间:{entry.TimeGenerated}");
                        Console.WriteLine($"来源:{entry.Source}");
                        Console.WriteLine($"事件ID:{entry.InstanceId}");
                        Console.WriteLine($"日志内容:{entry.Message}");
                        Console.WriteLine();
                    }
                }
            }
        }

        private static void WriteLogToApplication()
        {
            //需要先注册一个来源，跟日志绑定
            if (!EventLog.SourceExists("MyApplicationLogSource"))
            {
                EventLog.CreateEventSource("MyApplicationLogSource", "Application");
            }

            //注意，事件Id的范围是0-65535
            EventLog.WriteEntry("MyApplicationLogSource", "测试日志内容", EventLogEntryType.Warning, 63323);
        }

        private static void WriteLogToCustomLog()
        {
            //创建来源并跟日志（MyLog）绑定
            if (!EventLog.SourceExists("MySource"))
            {
                EventLog.CreateEventSource("MySource", "MyLog");
            }

            //写入记录到MyLog下
            EventLog.WriteEntry("MySource", "你可以指定日志内容", EventLogEntryType.Warning, 10010);
        }

        private static void ClearLogEntry(string logName)
        {
            //获取所有事件日志
            var logs = EventLog.GetEventLogs();

            foreach (var item in logs)
            {
                if (item.LogDisplayName == logName)
                {
                    //清除所有记录
                    item.Clear();
                    break;
                }
            }
        }

        private static void DeleteLog()
        {
            //删除日志来源
            EventLog.DeleteEventSource("MySource");
            //删除日志
            EventLog.Delete("MyLog");
        }
    }
}
